'use strict';

var express    = require('express'),
    path       = require('path'),
    config     = require('./config'),
    bodyParser = require('body-parser'),
    flash      = require('connect-flash'),
    session    = require('express-session'),
    cookieParser = require('cookie-parser'),
    passport   = require('passport')

module.exports = function(app) {
    app.set('views', config.root+ '/server/views')
    app.engine('html', require('ejs').renderFile)
    app.set('view engine', 'html')
    app.use('/workspace', express.static('./workspace/'))
    app.use(bodyParser.json())
    app.use(cookieParser())
    app.use(session({ 
        secret: '123',
        resave: true,
        saveUninitialized: true
    }))
    app.use(flash())
    app.use(passport.initialize())
    app.use(passport.session())

    if(app.get('env') === 'development') {
        app.use('/client/', express.static('./client/'))
        app.use(express.static(path.join(config.root, 'client')))
    } else if(app.get('env') === 'production') {
        app.use('/dist/', express.static('./dist/'))
        app.use(express.static(path.join(config.root, 'dist')))
    }
};
